#include<stdio.h>
#include<math.h>

int main(){

  /* Euler法で一階微分方程式を解くプログラム 
     実行すると標準出力にx, yが出るためグラフにプロットするには
     ./a.out > result.dat
     などとしてファイルにリダイレクトする。(a.outはコンパイル時に指定した実行ファイル名)
     この場合 result.datに標準出力に出るデータが保存される。 */

  double x,y, h=0.1;
  double f(double, double);

  /* 初期値を代入 */
  x = 0.0;
  y = 0.0;

  printf("%15.5f %15.5f\n", x, y); // 初期値を出力

  for(;x<20.0;){

    y += f(x,y)*h; // yを1ステップ進める
    
    x += h; // xを1ステップ進める。yより先に進めるとf(x,y)の中のxが更新されてしまうので注意
      
    printf("%15.5f %15.5f\n", x, y); // 1ステップ進んだ値を出力

  }

}

/* 1階微分dy/dxを与える関数 */

double f(double x, double y){
  return( cos(x));
}
