#include<stdio.h>
#include<math.h>

int main(){

  /* 4次のRunge-Kutta法で一階微分方程式を解くプログラム */

  double x,y, h=0.1;
  double k1, k2, k3, k4;
  double f(double, double);

  /* 初期値を代入*/ 
  x = 0.0;
  y = 0.0;
  
  printf("%15.5f %15.5f\n", x, y); // 初期値を出力

  for(;x<20.0;){

    k1 = h*f(x,y);
    k2 = h*f(x+h/2.0, y+k1/2.0);
    k3 = h*f(x+h/2.0, y+k2/2.0);
    k4 = h*f(x+h, y+k3);

    x += h; // xを1ステップ進める
    y += (k1 + 2.0*k2 + 2.0*k3 + k4)/6.0;
           
    printf("%15.5f %15.5f\n", x, y); // 1ステップ進んだ値を出力

  }

}

/* 1階微分dy/dxを与える関数 */

double f(double x, double y){
  return( cos(x));
}
