#include<stdio.h>
#include<math.h>

int main(){

  /* z方向の運動方程式を解くプログラム */

  double t, z, v, h=0.1;
  double k1, k2, k3, k4, l1, l2, l3, l4;
  double f(double, double, double);

  /* 初期値を代入*/ 
  t = 0.0;
  z = 0.0;
  v = 100.0;
  
  printf("%15.5f %15.5f %15.5f\n", t, v, z); // 初期値を出力

  for(;;){

    /* ルンゲクッタ法で計算 */
    k1 = h*v;
    l1 = h*f(t,v,z);
    k2 = h*(v + l1/2.0);
    l2 = h*f(t+h/2.0,v+l1/2.0, z+k1/2.0);
    k3 = h*(v + l2/2.0);
    l3 = h*f(t+h/2.0,v+l2/2.0, z+k2/2.0);
    k4 = h*(v + l3);
    l4 = h*f(t+h,v+l3, z+k3);

    /* 1ステップ進める */
    t += h;
    z += (k1 + 2.0*k2 + 2.0*k3 + k4)/6.0;
    v += (l1 + 2.0*l2 + 2.0*l3 + l4)/6.0;
           
    printf("%15.5f %15.5f %15.5f\n", t, v, z); // 1ステップ進んだ値を出力

    if( z< 0.0) break; // zが負(地面に接触)でDOループから抜ける
    
  }

}

/* vの1階微分を計算する関数 */

double f(double t, double v, double z){
  double g = 9.8,  km = 0.5, val;

  val = -g -km*v;
  return(val);
  
}
